## mingw-w64-boost-1.87.0-1.src.tar.zst

=== libs/atomic/test/CMakeLists.txt ===
# Copyright 2024 Andrey Semashev
#
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

include(BoostTest OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

if (NOT HAVE_BOOST_TEST)
    return()
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(BOOST_TEST_COMPILE_FEATURES
    cxx_lambdas
    cxx_static_assert
    cxx_deleted_functions
    cxx_defaulted_functions
)

set(BOOST_TEST_LINK_LIBRARIES
    Boost::atomic
    Boost::config
    Boost::core
    Boost::type_traits
)

if (WIN32)
    set(BOOST_TEST_COMPILE_DEFINITIONS
        "_CRT_SECURE_NO_WARNINGS"
        "_CRT_SECURE_NO_DEPRECATE"
        "BOOST_USE_WINDOWS_H"
    )
    list(APPEND BOOST_TEST_LINK_LIBRARIES
        Boost::winapi
    )
    if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        list(APPEND BOOST_TEST_LINK_LIBRARIES
            kernel32
        )
    endif()
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(BOOST_TEST_COMPILE_OPTIONS "-Wall" "-Wextra" "-Werror")
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(BOOST_TEST_COMPILE_OPTIONS "/W4" "/WX")
endif()

boost_test(TYPE run SOURCES atomic_api.cpp)
boost_test(TYPE run SOURCES atomic_ref_api.cpp)
boost_test(TYPE run SOURCES atomic_api.cpp COMPILE_DEFINITIONS BOOST_ATOMIC_FORCE_FALLBACK NAME fallback_atomic_api)
boost_test(TYPE run SOURCES atomic_ref_api.cpp COMPILE_DEFINITIONS BOOST_ATOMIC_FORCE_FALLBACK NAME fallback_atomic_ref_api)
boost_test(TYPE run SOURCES wait_api.cpp)
boost_test(TYPE run SOURCES wait_ref_api.cpp)
boost_test(TYPE run SOURCES wait_api.cpp COMPILE_DEFINITIONS BOOST_ATOMIC_FORCE_FALLBACK NAME fallback_wait_api)
boost_test(TYPE run SOURCES wait_ref_api.cpp COMPILE_DEFINITIONS BOOST_ATOMIC_FORCE_FALLBACK NAME fallback_wait_ref_api)
boost_test(TYPE run SOURCES wait_fuzz.cpp)
boost_test(TYPE run SOURCES wait_fuzz.cpp COMPILE_DEFINITIONS BOOST_ATOMIC_FORCE_FALLBACK NAME fallback_wait_fuzz)
boost_test(TYPE run SOURCES ipc_atomic_api.cpp)
boost_test(TYPE run SOURCES ipc_atomic_ref_api.cpp)
boost_test(TYPE run SOURCES ipc_wait_api.cpp)
boost_test(TYPE run SOURCES ipc_wait_ref_api.cpp)
boost_test(TYPE run SOURCES atomicity.cpp)
boost_test(TYPE run SOURCES atomicity_ref.cpp)
boost_test(TYPE run SOURCES ordering.cpp)
boost_test(TYPE run SOURCES ordering_ref.cpp)
boost_test(TYPE run SOURCES lockfree.cpp)

unset(BOOST_TEST_COMPILE_OPTIONS)

boost_test(TYPE compile-fail SOURCES cf_arith_void_ptr.cpp)
boost_test(TYPE compile-fail SOURCES cf_arith_func_ptr.cpp)
boost_test(TYPE compile-fail SOURCES cf_arith_mem_ptr.cpp)

boost_test(TYPE compile SOURCES c_implicit_ctor.cpp)

=== libs/lockfree/test/CMakeLists.txt ===
if(NOT TARGET boost_lockfree_all_tests)
    add_custom_target(boost_lockfree_all_tests)
endif()

include(BoostTest)

if (BOOST_LOCKFREE_BUILD_TESTS)
    set(BUILD_TESTING TRUE)
endif()

if (NOT BUILD_TESTING AND NOT TARGET tests)
    add_custom_target(tests)
endif()

add_library(boost_lockfree_test_common INTERFACE)

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.23)
  target_sources(boost_lockfree_test_common PUBLIC FILE_SET HEADERS FILES test_common.hpp test_helpers.hpp )
  source_group( TREE "${CMAKE_CURRENT_SOURCE_DIR}" FILES test_common.hpp test_helpers.hpp)
endif()

set(Tests
    destructor_test
    freelist_test
    queue_bounded_stress_test
    queue_fixedsize_stress_test
    queue_interprocess_test
    queue_test
    queue_unbounded_stress_test
    spsc_queue_stress_test
    spsc_queue_test
    stack_bounded_stress_test
    stack_fixedsize_stress_test
    stack_interprocess_test
    stack_test
    stack_unbounded_stress_test
    tagged_ptr_test
)

foreach(Test ${Tests})
    set (Libs Boost::lockfree
              Boost::unit_test_framework
              Boost::thread
              boost_lockfree_test_common)

    if (Test MATCHES ".*interprocess.*")
        list(APPEND Libs Boost::interprocess)
    endif()

    source_group( TREE "${CMAKE_CURRENT_SOURCE_DIR}" FILES ${Test}.cpp)

    boost_test(
        TYPE run
        PREFIX boost_lockfree
        NAME ${Test}
        SOURCES ${Test}.cpp
        LINK_LIBRARIES ${Libs}
        COMPILE_DEFINITIONS BOOST_TEST_NO_OLD_TOOLS
    )
    set_target_properties( boost_lockfree-${Test} PROPERTIES CMAKE_CXX_STANDARD_REQUIRED 14)

    if (TARGET boost_lockfree-${Test})
        add_dependencies(boost_lockfree_all_tests boost_lockfree-${Test} )
    endif()

endforeach()

=== libs/compat/test/cmake_install_test/CMakeLists.txt ===
# Copyright 2018, 2019, 2023 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(cmake_install_test LANGUAGES CXX)

find_package(boost_compat REQUIRED)

add_executable(quick ../quick.cpp)
target_link_libraries(quick Boost::compat)

enable_testing()
add_test(quick quick)

add_custom_target(check VERBATIM COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

=== libs/geometry/test/io/CMakeLists.txt ===
# Boost.Geometry
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Use, modification and distribution is subject to the Boost Software License,
# Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

add_subdirectory(dsv)
add_subdirectory(svg)
add_subdirectory(wkt)

=== libs/json/test/cmake-subdir/CMakeLists.txt ===
#
# Copyright (c) 2023 Dmitry Arkhipov (grisumbras@yandex.ru)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Official repository: https://github.com/boostorg/json
#

cmake_minimum_required(VERSION 3.8...3.16)

project(myproject LANGUAGES CXX)

add_subdirectory(../../../align           boostorg/align)
add_subdirectory(../../../assert          boostorg/assert)
add_subdirectory(../../../config          boostorg/config)
add_subdirectory(../../../container       boostorg/container)
add_subdirectory(../../../container_hash  boostorg/container_hash)
add_subdirectory(../../../core            boostorg/core)
add_subdirectory(../../../describe        boostorg/describe)
add_subdirectory(../../../endian          boostorg/endian)
add_subdirectory(../../../intrusive       boostorg/intrusive)
add_subdirectory(../../../json            boostorg/json)
add_subdirectory(../../../move            boostorg/move)
add_subdirectory(../../../mp11            boostorg/mp11)
add_subdirectory(../../../predef          boostorg/predef)
add_subdirectory(../../../system          boostorg/system)
add_subdirectory(../../../throw_exception boostorg/throw_exception)
add_subdirectory(../../../static_assert   boostorg/static_assert)
add_subdirectory(../../../variant2        boostorg/variant2)
add_subdirectory(../../../winapi          boostorg/winapi)

add_executable(mytest main.cpp)
target_link_libraries(mytest PRIVATE Boost::json)

enable_testing()
add_test(mytest mytest)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure --no-tests=error -C $<CONFIG>)
add_dependencies(check mytest)

=== libs/smart_ptr/test/cmake_subdir_test/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(cmake_subdir_test LANGUAGES CXX)

add_subdirectory(../.. boostorg/smart_ptr)
add_subdirectory(../../../assert boostorg/assert)
add_subdirectory(../../../config boostorg/config)
add_subdirectory(../../../core boostorg/core)
add_subdirectory(../../../move boostorg/move)
add_subdirectory(../../../static_assert boostorg/static_assert)
add_subdirectory(../../../throw_exception boostorg/throw_exception)
add_subdirectory(../../../type_traits boostorg/type_traits)

add_executable(quick ../quick.cpp)
target_link_libraries(quick Boost::smart_ptr Boost::core)

enable_testing()
add_test(quick quick)

add_custom_target(check VERBATIM COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

=== tools/cmake/test/preprocessor/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_preprocessor_install_test LANGUAGES CXX)

find_package(boost_preprocessor REQUIRED)

add_executable(main main.cpp)
target_link_libraries(main Boost::preprocessor)

enable_testing()
add_test(NAME main COMMAND main)

add_custom_target(check VERBATIM COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure --no-tests=error -C $<CONFIG>)

=== libs/geometry/test/algorithms/set_operations/CMakeLists.txt ===
# Boost.Geometry
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Use, modification and distribution is subject to the Boost Software License,
# Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

add_subdirectory(union)
add_subdirectory(intersection)
add_subdirectory(difference)
add_subdirectory(sym_difference)

=== libs/msm/doc/PDF/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)

# project-specific includes
include_directories(.)
include_directories(../../../include)


IF (WIN32)
include_directories(C:/dev/boost_1_84_0)
set(LIBS_BOOST C:/dev/boost_1_84_0/stage/lib)
ELSE()
include_directories(/home/bob/.vs/boost_1_84_0)
set(LIBS_BOOST /home/bob/.vs/boost_1_84_0/stage/lib)
ENDIF()


# set the project name
project(msm_examples)

# specify the C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED True)

if (MSVC)
  add_compile_options(/bigobj)
else ()

endif ()


# add the executable
add_executable( msm_examples
                #back
                ../../../include/boost/msm/back/state_machine.hpp
                ../../../include/boost/msm/back/metafunctions.hpp
                ../../../include/boost/msm/back/dispatch_table.hpp
                #back11
                ../../../include/boost/msm/back11/state_machine.hpp
                ../../../include/boost/msm/back11/metafunctions.hpp
                ../../../include/boost/msm/back11/dispatch_table.hpp
                #front
                ../../../include/boost/msm/front/state_machine_def.hpp
                ../../../include/boost/msm/front/states.hpp
                ../../../include/boost/msm/front/functor_row.hpp
                ../../../include/boost/msm/front/euml/euml_typeof.hpp
                ../../../include/boost/msm/front/euml/state_grammar.hpp
                ../../../include/boost/msm/front/euml/common.hpp
                #sources
                ${PROJECT_SOURCE_DIR}/History.cpp
              )

target_include_directories(msm_examples PUBLIC ${INCLUDE_ASYNCHRONOUS})


IF (WIN32)
target_link_directories(msm_examples PUBLIC ${LIBS_BOOST})
ELSE()
target_link_libraries(msm_examples rt)
target_link_libraries(msm_examples stdc++fs)
target_link_libraries(msm_examples pthread)
target_link_libraries(msm_examples stdc++)
target_link_libraries(msm_examples m)

target_link_libraries(msm_examples ${LIBS_BOOST}/libboost_unit_test_framework.a)
target_link_libraries(msm_examples ${LIBS_BOOST}/libboost_serialization.a)
ENDIF()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=boost
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-libs")
pkgver=1.87.0
pkgrel=1
pkgdesc="Free peer-reviewed portable C++ source libraries"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.boost.org/"
msys2_repository_url="https://github.com/boostorg/boost"
msys2_references=(
  'archlinux: boost'
  "cpe: cpe:/a:boost:boost"
)
license=('spdx:BSL-1.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-icu"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zstd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             $([[ ${CARCH} == i686 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-python" \
               "${MINGW_PACKAGE_PREFIX}-python-numpy"))
source=(https://github.com/boostorg/boost/releases/download/boost-${pkgver}/boost-${pkgver}-cmake.tar.xz
        0001-Fix-building-with-cmake-on-MINGW.patch
        0002-No-Arch-in-library-name-tag.patch
        0003-fix-build-context-with-CMake-on-arm64.patch
        boost-1.63.0-python-test-PyImport_AppendInittab.patch)
sha256sums=('7da75f171837577a52bbf217e17f8ea576c7c246e4594d617bfde7fafd408be5'
            'abc6c78a252165df1de504d854d942eb486d88f06a6423d8b99dfec6ab138170'
            'ee45d199c0e578a8d670ee6c6fa46466a53a02690c94f9221c67bbc9ab3387dc'
            'ac6f996db2d5e2e5870b1a2d26c3b7d022f09d5be94945451d90875e8d4ecda4'
            'b22196b6415f5e1c0fe56b49a12ea7c20073b15a5f31907f363c7be38d70d628')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # https://bugzilla.redhat.com/show_bug.cgi?id=1102667
  apply_patch_with_msg \
    boost-1.63.0-python-test-PyImport_AppendInittab.patch

  apply_patch_with_msg \
    0001-Fix-building-with-cmake-on-MINGW.patch \
    0002-No-Arch-in-library-name-tag.patch \
    0003-fix-build-context-with-CMake-on-arm64.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ "${CARCH}" != "i686" ]]; then
    _extra_config+=('-DBOOST_ENABLE_PYTHON=ON')
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS="OFF" \
      -DBOOST_INSTALL_LAYOUT=tagged \
      -DBOOST_STACKTRACE_ENABLE_FROM_EXCEPTION=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DBUILD_TESTING=OFF \
      -S ${_realname}-${pkgver} \
      -B build-${MSYSTEM}-static

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}-static

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS="ON" \
      -DBOOST_INSTALL_LAYOUT=tagged \
      -DBOOST_STACKTRACE_ENABLE_FROM_EXCEPTION=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DBUILD_TESTING=OFF \
      -S ${_realname}-${pkgver} \
      -B build-${MSYSTEM}

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
}

package_boost() {
  pkgdesc+=" (mingw-w64)"
  depends=("${MINGW_PACKAGE_PREFIX}-boost-libs")
  if [[ ${CARCH} != i686 ]]; then
    optdepends=("${MINGW_PACKAGE_PREFIX}-python: For Boost.Python"
                "${MINGW_PACKAGE_PREFIX}-python-numpy: For Boost.Python (NumPy)")
  fi

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install build-${MSYSTEM}-static
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE_1_0.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  # split runtime libraries
  mkdir -p dest${MINGW_PREFIX}/bin
  mv "${pkgdir}${MINGW_PREFIX}"/bin/*.dll dest${MINGW_PREFIX}/bin/
}

package_boost-libs() {
  pkgdesc+=" (runtime libraries) (mingw-w64)"

  mv dest/* "${pkgdir}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE_1_0.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}-libs/LICENSE
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
